//  File:  RandomRange.java - show how to build a method that 
//         returns a (pseudo-)random int in a given range

public class RandomRange {

    /**
     *    Drive randomRange()
     */
    RandomRange() {
        System.out.println("\nRandomRange\n");
        runRandomRange(50, 0, 1);
        runRandomRange(50, 0, 4);
        runRandomRange(50, 0, 9);
        runRandomRange(50, 4, 6);
        runRandomRange(40, -1, 1);
        runRandomRange(40, -3, 3);
        runRandomRange(40, -9, 9);
        runRandomRange(40, -9, 9);
        runRandomRange(40, 0, 20);
        System.out.println();
    }

    /**
     *    Run randomRange(lo, hi) n times
     */
    void runRandomRange(int n, int lo, int hi) {
        System.out.print("[" + lo + "," + hi + ") ");
        for (int i = 0; i < n; i++)
            System.out.print(" " + randomRange(lo, hi));
        System.out.println();
    }

    /**
     *    randomRange(lo, hi) returns a random int in 
     *    the range lo..hi, inclusive
     */
    int randomRange(int lo, int hi) {
        int range = hi - lo + 1;
        return lo + (int) (range * Math.random());
    }

    public static void main(String[] argv) {
        new RandomRange();
    }

}

/* ----- Output from RandomRange -----

RandomRange

[0,1)  0 1 0 1 1 0 0 1 1 1 1 1 1 0 1 0 0 1 0 0 0 0 1 1 0 1 1 0 1 0 0 0 0 0 1 0 1 0 1 1 0 1 0 1 1 0 1 1 1 1
[0,4)  0 4 2 3 3 1 2 2 4 4 2 4 0 3 4 4 3 2 4 1 2 2 3 1 2 3 1 0 0 3 4 3 2 1 0 1 4 2 0 1 1 1 3 2 1 1 2 3 0 0
[0,9)  1 3 0 6 2 2 1 0 1 0 9 6 3 3 4 0 5 4 4 0 0 5 9 5 3 1 4 3 2 7 4 7 5 0 9 9 1 4 1 2 9 3 9 0 4 7 9 6 0 6
[4,6)  6 4 6 5 6 6 4 5 4 5 5 6 5 4 6 6 5 6 4 4 6 4 4 6 5 4 4 4 6 4 4 5 4 4 6 4 6 6 6 6 4 5 4 6 5 5 5 5 5 5
[-1,1)  1 1 0 0 0 1 -1 -1 1 1 0 -1 -1 0 0 1 -1 1 0 0 0 0 -1 1 -1 1 1 0 -1 0 -1 -1 0 1 -1 0 -1 -1 1 0
[-3,3)  2 -1 -1 -2 -3 -1 2 1 -3 2 3 -1 -2 -3 1 -1 -3 -2 2 3 3 3 2 -1 1 -3 0 0 2 2 -3 -2 3 -2 1 0 2 0 2 2
[-9,9)  -1 7 -9 -2 5 -3 -1 2 7 -4 -7 5 -9 -3 3 6 9 4 -3 8 -5 -9 -8 -6 -8 -4 7 -8 -4 -9 9 -7 -7 2 7 -8 -5 2 -1 -3
[-9,9)  -6 -5 -1 -4 5 -9 7 -5 -7 8 -7 -4 -5 -4 6 3 3 6 -2 6 5 -5 5 -5 -7 -4 -4 9 -1 7 4 7 -8 -7 4 2 4 0 -2 -6
[0,20)  4 11 5 12 8 8 16 18 11 19 18 0 2 12 17 18 17 1 5 9 16 11 7 6 7 18 0 8 8 19 9 4 10 13 5 8 11 12 8 17

---------- end output ---------- */
